import BaseCurdEntry from './BaseCurdEntry'
import DataTimeRange from '@/utils/DataTimeRange'
import TagType from './TagType'
import TagPurchaseState from './TagPurchaseState'

import tagPurchaseApi from '@/api/TagPurchaseApi'

export default class TagPurchase extends BaseCurdEntry {
  id

  dataTime
  get formatDataTime () {
    return new Date(this.dataTime).format('YYYY-MM-DD')
  }

  orderNo

  tagTypeId
  get tagTypeName () {
    const config = TagPurchase.$$optionData.TagType
    if (config) {
      const option = config.map[this.tagTypeId]
      if (option) {
        return option[TagType.$$nameProp]
      }
    }

    return ''
  }

  number

  amount

  buyerName

  receiveDate
  get formatReceiveDate () {
    return new Date(this.receiveDate).format('YYYY-MM-DD')
  }

  tagPurchaseStateId
  get tagPurchaseStateName () {
    const config = TagPurchase.$$optionData.TagPurchaseState
    if (config) {
      const option = config.map[this.tagPurchaseStateId]
      if (option) {
        return option[TagPurchaseState.$$nameProp]
      }
    }

    return ''
  }

  static get $$api () {
    return tagPurchaseApi
  }

  static $$getQuery = () => ({
    ...(new DataTimeRange({
      unit: 'Date',
      diff: 7,
      offset: 0
    })),
    tagPurchaseStateId: '',
    order: [['dataTime', 'DESC']]
  })

  static $$optionTargetConfigGroup = [
    [{
      target: TagType
    }, {
      target: TagPurchaseState,
      setQuery: (options, query, Target) => {
        const [ option ] = options
        if (option) {
          query.tagPurchaseStateId = option[Target.$$idProp]
        }
      }
    }]
  ]

  static $$optionData = {}
}
